/**
 *
 *  Class VsmlEvaluateAllVisitor.java
 *
 *  Generated by KMFStudio at 23 April 2004 18:03:54
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.kmf.studio.vsml;

import java.util.*;

import uk.ac.kent.cs.kmf.util.*;
import uk.ac.kent.cs.ocl20.standard.lib.*;
import uk.ac.kent.cs.ocl20.bridge4kmf.*;

public class VsmlEvaluateAllVisitor$Class
	extends VsmlVisitor$Class
	implements VsmlEvaluateAllVisitor
{
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv targetOf_size: 0<=targetOf->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'targetOf'
			OclBag t3 = StdLibAdapterImpl.INSTANCE.Bag(self.getTargetOf());
			// Call operation 'size'
			OclInteger t2 = (OclInteger)t3.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t1 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t2);

			//--- Print result ---
			log.reportMessage(": "+t1);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv targetOf_bidirectional: targetOf->forAll(x | x.target=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'targetOf'
			OclBag t4 = StdLibAdapterImpl.INSTANCE.Bag(self.getTargetOf());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd x = null;
			//--- Init flag ---
			OclBoolean t5 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t6 = StdLibAdapterImpl.INSTANCE.impl(t4).iterator();
			while (t6.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t6.next();
				//--- Compute body ---
				// Call property 'target'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t8 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)x.getTarget();
				// Call operation 'equalTo'
				OclBoolean t7 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t8, self));
				t5 = t7;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t5).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t5);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv sourceOf_size: 0<=sourceOf->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'sourceOf'
			OclBag t11 = StdLibAdapterImpl.INSTANCE.Bag(self.getSourceOf());
			// Call operation 'size'
			OclInteger t10 = (OclInteger)t11.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t9 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t10);

			//--- Print result ---
			log.reportMessage(": "+t9);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv sourceOf_bidirectional: sourceOf->forAll(x | x.source=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'sourceOf'
			OclBag t12 = StdLibAdapterImpl.INSTANCE.Bag(self.getSourceOf());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd x = null;
			//--- Init flag ---
			OclBoolean t13 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t14 = StdLibAdapterImpl.INSTANCE.impl(t12).iterator();
			while (t14.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t14.next();
				//--- Compute body ---
				// Call property 'source'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t16 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)x.getSource();
				// Call operation 'equalTo'
				OclBoolean t15 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t16, self));
				t13 = t15;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t13).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t13);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv owner_bidirectional: Set{owner}->forAll(x | x.class_->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t17 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'owner'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t18 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)self.getOwner();
			t17 = t17.including(t18);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ x = null;
			//--- Init flag ---
			OclBoolean t19 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t20 = StdLibAdapterImpl.INSTANCE.impl(t17).iterator();
			while (t20.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t20.next();
				//--- Compute body ---
				// Call property 'class_'
				OclBag t22 = StdLibAdapterImpl.INSTANCE.Bag(x.getClass_());
				// Call operation 'includes'
				OclBoolean t21 = (OclBoolean)t22.includes(self);
				t19 = t21;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t19).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t19);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Class_ inv superClass_size: 0<=superClass->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'superClass'
			OclBag t25 = StdLibAdapterImpl.INSTANCE.Bag(self.getSuperClass());
			// Call operation 'size'
			OclInteger t24 = (OclInteger)t25.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t23 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t24);

			//--- Print result ---
			log.reportMessage(": "+t23);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::Class_ inv names_of_assoc_ends_are_unique : sourceOf . name -> asSet() -> asBag() = sourceOf . name";
		log.printMessage("  "+invariant);

		try {
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'sourceOf'
			OclBag t29 = StdLibAdapterImpl.INSTANCE.Bag(self.getSourceOf());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd _tempIt1 = null;
			//--- Init result ---
			OclBag t30 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t31 = StdLibAdapterImpl.INSTANCE.impl(t29).iterator();
			while (t31.hasNext()) {
				_tempIt1 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t31.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t32 = StdLibAdapterImpl.INSTANCE.String(_tempIt1.getName());
				//--- Add body to result ---
				t30 = t30.including(t32);
			}
			//--- Flatten the collection ---
			t30 = t30.flatten();
			// Call operation 'asSet'
			OclSet t28 = (OclSet)t30.asSet();
			// Call operation 'asBag'
			OclBag t27 = (OclBag)t28.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'sourceOf'
			OclBag t33 = StdLibAdapterImpl.INSTANCE.Bag(self.getSourceOf());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd _tempIt0 = null;
			//--- Init result ---
			OclBag t34 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t35 = StdLibAdapterImpl.INSTANCE.impl(t33).iterator();
			while (t35.hasNext()) {
				_tempIt0 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t35.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t36 = StdLibAdapterImpl.INSTANCE.String(_tempIt0.getName());
				//--- Add body to result ---
				t34 = t34.including(t36);
			}
			//--- Flatten the collection ---
			t34 = t34.flatten();
			// Call operation 'equalTo'
			OclBoolean t26 = StdLibAdapterImpl.INSTANCE.Boolean(t27.equals(t34));

			//--- Print result ---
			log.reportMessage(": "+t26);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		//--- Print invariant ---
		invariant = "context vsml::AS::AssociationEnd inv owner_bidirectional: Set{owner}->forAll(x | x.associationEnd->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t37 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'owner'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Association t38 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)self.getOwner();
			t37 = t37.including(t38);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Association x = null;
			//--- Init flag ---
			OclBoolean t39 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t40 = StdLibAdapterImpl.INSTANCE.impl(t37).iterator();
			while (t40.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)t40.next();
				//--- Compute body ---
				// Call property 'associationEnd'
				OclSequence t42 = StdLibAdapterImpl.INSTANCE.Sequence(x.getAssociationEnd());
				// Call operation 'includes'
				OclBoolean t41 = (OclBoolean)t42.includes(self);
				t39 = t41;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t39).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t39);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::AssociationEnd inv target_bidirectional: Set{target}->forAll(x | x.targetOf->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t43 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'target'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t44 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)self.getTarget();
			t43 = t43.including(t44);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ x = null;
			//--- Init flag ---
			OclBoolean t45 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t46 = StdLibAdapterImpl.INSTANCE.impl(t43).iterator();
			while (t46.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t46.next();
				//--- Compute body ---
				// Call property 'targetOf'
				OclBag t48 = StdLibAdapterImpl.INSTANCE.Bag(x.getTargetOf());
				// Call operation 'includes'
				OclBoolean t47 = (OclBoolean)t48.includes(self);
				t45 = t47;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t45).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t45);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::AssociationEnd inv source_bidirectional: Set{source}->forAll(x | x.sourceOf->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t49 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'source'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t50 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)self.getSource();
			t49 = t49.including(t50);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ x = null;
			//--- Init flag ---
			OclBoolean t51 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t52 = StdLibAdapterImpl.INSTANCE.impl(t49).iterator();
			while (t52.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t52.next();
				//--- Compute body ---
				// Call property 'sourceOf'
				OclBag t54 = StdLibAdapterImpl.INSTANCE.Bag(x.getSourceOf());
				// Call operation 'includes'
				OclBoolean t53 = (OclBoolean)t54.includes(self);
				t51 = t53;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t51).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t51);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::AssociationEnd inv otherEnd_source_is_target : otherEnd -> isEmpty() or ( otherEnd . target = source and otherEnd . source = target )";
		log.printMessage("  "+invariant);

		try {
			OclBoolean t56;
			try {
				OclSet t58 = StdLibAdapterImpl.INSTANCE.Set();
				// Call property 'otherEnd'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t59 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
				t58 = t58.including(t59);
				// Call operation 'isEmpty'
				OclBoolean t57 = (OclBoolean)t58.isEmpty();
				t56 = t57;
			} catch (Exception e) {
				t56 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			OclBoolean t60;
			try {
				OclBoolean t62;
				try {
					// Call property 'otherEnd'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t65 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
					// Call property 'target'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t64 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t65.getTarget();
					// Call property 'source'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t66 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)self.getSource();
					// Call operation 'equalTo'
					OclBoolean t63 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t64, t66));
					t62 = t63;
				} catch (Exception e) {
					t62 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				OclBoolean t67;
				try {
					// Call property 'otherEnd'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t70 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
					// Call property 'source'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t69 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t70.getSource();
					// Call property 'target'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ t71 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)self.getTarget();
					// Call operation 'equalTo'
					OclBoolean t68 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t69, t71));
					t67 = t68;
				} catch (Exception e) {
					t67 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				// Call operation 'and'
				OclBoolean t61 = t62.and(t67);
				t60 = t61;
			} catch (Exception e) {
				t60 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			// Call operation 'or'
			OclBoolean t55 = t56.or(t60);

			//--- Print result ---
			log.reportMessage(": "+t55);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::AssociationEnd inv otherEnd_owner_is_owner_and_not_self : otherEnd -> isEmpty() or ( otherEnd . owner = owner and not ( otherEnd = self ) )";
		log.printMessage("  "+invariant);

		try {
			OclBoolean t73;
			try {
				OclSet t75 = StdLibAdapterImpl.INSTANCE.Set();
				// Call property 'otherEnd'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t76 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
				t75 = t75.including(t76);
				// Call operation 'isEmpty'
				OclBoolean t74 = (OclBoolean)t75.isEmpty();
				t73 = t74;
			} catch (Exception e) {
				t73 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			OclBoolean t77;
			try {
				OclBoolean t79;
				try {
					// Call property 'otherEnd'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t82 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
					// Call property 'owner'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Association t81 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)t82.getOwner();
					// Call property 'owner'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.Association t83 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)self.getOwner();
					// Call operation 'equalTo'
					OclBoolean t80 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t81, t83));
					t79 = t80;
				} catch (Exception e) {
					t79 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				OclBoolean t84;
				try {
					// Call property 'otherEnd'
					uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t87 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)self.getOtherEnd();
					// Call operation 'equalTo'
					OclBoolean t86 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t87, self));
					// Call operation 'not'
					OclBoolean t85 = (OclBoolean)t86.not();
					t84 = t85;
				} catch (Exception e) {
					t84 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				// Call operation 'and'
				OclBoolean t78 = t79.and(t84);
				t77 = t78;
			} catch (Exception e) {
				t77 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			// Call operation 'or'
			OclBoolean t72 = t73.or(t77);

			//--- Print result ---
			log.reportMessage(": "+t72);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::AssociationEnd inv upper_greater_than_lower : upper -> isEmpty() or upper >= lower";
		log.printMessage("  "+invariant);

		try {
			OclBoolean t89;
			try {
				OclSet t91 = StdLibAdapterImpl.INSTANCE.Set();
				// Call property 'upper'
				OclInteger t92 = StdLibAdapterImpl.INSTANCE.Integer(self.getUpper());
				t91 = t91.including(t92);
				// Call operation 'isEmpty'
				OclBoolean t90 = (OclBoolean)t91.isEmpty();
				t89 = t90;
			} catch (Exception e) {
				t89 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			OclBoolean t93;
			try {
				// Call property 'upper'
				OclInteger t95 = StdLibAdapterImpl.INSTANCE.Integer(self.getUpper());
				// Call property 'lower'
				OclInteger t96 = StdLibAdapterImpl.INSTANCE.Integer(self.getLower());
				// Call operation 'greaterThanOrEqualTo'
				OclBoolean t94 = (OclBoolean)t95.greaterThanOrEqualTo(t96);
				t93 = t94;
			} catch (Exception e) {
				t93 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			// Call operation 'or'
			OclBoolean t88 = t89.or(t93);

			//--- Print result ---
			log.reportMessage(": "+t88);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv class__size: 0<=class_->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'class_'
			OclBag t99 = StdLibAdapterImpl.INSTANCE.Bag(self.getClass_());
			// Call operation 'size'
			OclInteger t98 = (OclInteger)t99.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t97 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t98);

			//--- Print result ---
			log.reportMessage(": "+t97);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv class__bidirectional: class_->forAll(x | x.owner=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'class_'
			OclBag t100 = StdLibAdapterImpl.INSTANCE.Bag(self.getClass_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ x = null;
			//--- Init flag ---
			OclBoolean t101 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t102 = StdLibAdapterImpl.INSTANCE.impl(t100).iterator();
			while (t102.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t102.next();
				//--- Compute body ---
				// Call property 'owner'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t104 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)x.getOwner();
				// Call operation 'equalTo'
				OclBoolean t103 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t104, self));
				t101 = t103;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t101).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t101);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv association_size: 0<=association->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'association'
			OclBag t107 = StdLibAdapterImpl.INSTANCE.Bag(self.getAssociation());
			// Call operation 'size'
			OclInteger t106 = (OclInteger)t107.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t105 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t106);

			//--- Print result ---
			log.reportMessage(": "+t105);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv association_bidirectional: association->forAll(x | x.owner=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'association'
			OclBag t108 = StdLibAdapterImpl.INSTANCE.Bag(self.getAssociation());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Association x = null;
			//--- Init flag ---
			OclBoolean t109 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t110 = StdLibAdapterImpl.INSTANCE.impl(t108).iterator();
			while (t110.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)t110.next();
				//--- Compute body ---
				// Call property 'owner'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t112 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)x.getOwner();
				// Call operation 'equalTo'
				OclBoolean t111 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t112, self));
				t109 = t111;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t109).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t109);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv owner_bidirectional: Set{owner}->forAll(x | x.package_->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t113 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'owner'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t114 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)self.getOwner();
			t113 = t113.including(t114);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ x = null;
			//--- Init flag ---
			OclBoolean t115 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t116 = StdLibAdapterImpl.INSTANCE.impl(t113).iterator();
			while (t116.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t116.next();
				//--- Compute body ---
				// Call property 'package_'
				OclBag t118 = StdLibAdapterImpl.INSTANCE.Bag(x.getPackage_());
				// Call operation 'includes'
				OclBoolean t117 = (OclBoolean)t118.includes(self);
				t115 = t117;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t115).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t115);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv package__size: 0<=package_->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'package_'
			OclBag t121 = StdLibAdapterImpl.INSTANCE.Bag(self.getPackage_());
			// Call operation 'size'
			OclInteger t120 = (OclInteger)t121.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t119 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(0).lessThanOrEqualTo(t120);

			//--- Print result ---
			log.reportMessage(": "+t119);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Package_ inv package__bidirectional: package_->forAll(x | x.owner=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'package_'
			OclBag t122 = StdLibAdapterImpl.INSTANCE.Bag(self.getPackage_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ x = null;
			//--- Init flag ---
			OclBoolean t123 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t124 = StdLibAdapterImpl.INSTANCE.impl(t122).iterator();
			while (t124.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t124.next();
				//--- Compute body ---
				// Call property 'owner'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t126 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)x.getOwner();
				// Call operation 'equalTo'
				OclBoolean t125 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t126, self));
				t123 = t125;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t123).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t123);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::Package_ inv assoc_names_unique : association . name -> asSet() -> asBag() = association . name";
		log.printMessage("  "+invariant);

		try {
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'association'
			OclBag t130 = StdLibAdapterImpl.INSTANCE.Bag(self.getAssociation());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Association _tempIt3 = null;
			//--- Init result ---
			OclBag t131 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t132 = StdLibAdapterImpl.INSTANCE.impl(t130).iterator();
			while (t132.hasNext()) {
				_tempIt3 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)t132.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t133 = StdLibAdapterImpl.INSTANCE.String(_tempIt3.getName());
				//--- Add body to result ---
				t131 = t131.including(t133);
			}
			//--- Flatten the collection ---
			t131 = t131.flatten();
			// Call operation 'asSet'
			OclSet t129 = (OclSet)t131.asSet();
			// Call operation 'asBag'
			OclBag t128 = (OclBag)t129.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'association'
			OclBag t134 = StdLibAdapterImpl.INSTANCE.Bag(self.getAssociation());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Association _tempIt2 = null;
			//--- Init result ---
			OclBag t135 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t136 = StdLibAdapterImpl.INSTANCE.impl(t134).iterator();
			while (t136.hasNext()) {
				_tempIt2 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)t136.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t137 = StdLibAdapterImpl.INSTANCE.String(_tempIt2.getName());
				//--- Add body to result ---
				t135 = t135.including(t137);
			}
			//--- Flatten the collection ---
			t135 = t135.flatten();
			// Call operation 'equalTo'
			OclBoolean t127 = StdLibAdapterImpl.INSTANCE.Boolean(t128.equals(t135));

			//--- Print result ---
			log.reportMessage(": "+t127);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::Package_ inv class_names_unique : class_ . name -> asSet() -> asBag() = class_ . name";
		log.printMessage("  "+invariant);

		try {
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'class_'
			OclBag t141 = StdLibAdapterImpl.INSTANCE.Bag(self.getClass_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ _tempIt5 = null;
			//--- Init result ---
			OclBag t142 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t143 = StdLibAdapterImpl.INSTANCE.impl(t141).iterator();
			while (t143.hasNext()) {
				_tempIt5 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t143.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t144 = StdLibAdapterImpl.INSTANCE.String(_tempIt5.getName());
				//--- Add body to result ---
				t142 = t142.including(t144);
			}
			//--- Flatten the collection ---
			t142 = t142.flatten();
			// Call operation 'asSet'
			OclSet t140 = (OclSet)t142.asSet();
			// Call operation 'asBag'
			OclBag t139 = (OclBag)t140.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'class_'
			OclBag t145 = StdLibAdapterImpl.INSTANCE.Bag(self.getClass_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ _tempIt4 = null;
			//--- Init result ---
			OclBag t146 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t147 = StdLibAdapterImpl.INSTANCE.impl(t145).iterator();
			while (t147.hasNext()) {
				_tempIt4 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_)t147.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t148 = StdLibAdapterImpl.INSTANCE.String(_tempIt4.getName());
				//--- Add body to result ---
				t146 = t146.including(t148);
			}
			//--- Flatten the collection ---
			t146 = t146.flatten();
			// Call operation 'equalTo'
			OclBoolean t138 = StdLibAdapterImpl.INSTANCE.Boolean(t139.equals(t146));

			//--- Print result ---
			log.reportMessage(": "+t138);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::Package_ inv package_names_unique : package_ . name -> asSet() -> asBag() = package_ . name";
		log.printMessage("  "+invariant);

		try {
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'package_'
			OclBag t152 = StdLibAdapterImpl.INSTANCE.Bag(self.getPackage_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ _tempIt7 = null;
			//--- Init result ---
			OclBag t153 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t154 = StdLibAdapterImpl.INSTANCE.impl(t152).iterator();
			while (t154.hasNext()) {
				_tempIt7 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t154.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t155 = StdLibAdapterImpl.INSTANCE.String(_tempIt7.getName());
				//--- Add body to result ---
				t153 = t153.including(t155);
			}
			//--- Flatten the collection ---
			t153 = t153.flatten();
			// Call operation 'asSet'
			OclSet t151 = (OclSet)t153.asSet();
			// Call operation 'asBag'
			OclBag t150 = (OclBag)t151.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			// Call property 'package_'
			OclBag t156 = StdLibAdapterImpl.INSTANCE.Bag(self.getPackage_());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ _tempIt6 = null;
			//--- Init result ---
			OclBag t157 = StdLibAdapterImpl.INSTANCE.Bag();;
			//--- For each element from collection ---
			java.util.Iterator t158 = StdLibAdapterImpl.INSTANCE.impl(t156).iterator();
			while (t158.hasNext()) {
				_tempIt6 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t158.next();
				//--- Compute body ---
				// Call property 'name'
				OclString t159 = StdLibAdapterImpl.INSTANCE.String(_tempIt6.getName());
				//--- Add body to result ---
				t157 = t157.including(t159);
			}
			//--- Flatten the collection ---
			t157 = t157.flatten();
			// Call operation 'equalTo'
			OclBoolean t149 = StdLibAdapterImpl.INSTANCE.Boolean(t150.equals(t157));

			//--- Print result ---
			log.reportMessage(": "+t149);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Association' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Association self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		//--- Print invariant ---
		invariant = "context vsml::AS::Association inv associationEnd_size: 1<=associationEnd->size()";
		log.printMessage("  "+invariant);

		try {
			// Call property 'associationEnd'
			OclSequence t162 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
			// Call operation 'size'
			OclInteger t161 = (OclInteger)t162.size();
			// Call operation 'lessThanOrEqualTo'
			OclBoolean t160 = (OclBoolean)StdLibAdapterImpl.INSTANCE.Integer(1).lessThanOrEqualTo(t161);

			//--- Print result ---
			log.reportMessage(": "+t160);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Association inv associationEnd_bidirectional: associationEnd->forAll(x | x.owner=self)";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			// Call property 'associationEnd'
			OclSequence t163 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
			uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd x = null;
			//--- Init flag ---
			OclBoolean t164 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t165 = StdLibAdapterImpl.INSTANCE.impl(t163).iterator();
			while (t165.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t165.next();
				//--- Compute body ---
				// Call property 'owner'
				uk.ac.ukc.cs.kmf.studio.vsml.AS.Association t167 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Association)x.getOwner();
				// Call operation 'equalTo'
				OclBoolean t166 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t167, self));
				t164 = t166;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t164).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t164);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context vsml::AS::Association inv owner_bidirectional: Set{owner}->forAll(x | x.association->includes(self))";
		log.printMessage("  "+invariant);

		try {
			// 'forAll' iterator
			OclSet t168 = StdLibAdapterImpl.INSTANCE.Set();
			// Call property 'owner'
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ t169 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)self.getOwner();
			t168 = t168.including(t169);
			uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ x = null;
			//--- Init flag ---
			OclBoolean t170 = StdLibAdapterImpl.INSTANCE.Boolean(true);
			//--- For each element from collection ---
			java.util.Iterator t171 = StdLibAdapterImpl.INSTANCE.impl(t168).iterator();
			while (t171.hasNext()) {
				x = (uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_)t171.next();
				//--- Compute body ---
				// Call property 'association'
				OclBag t173 = StdLibAdapterImpl.INSTANCE.Bag(x.getAssociation());
				// Call operation 'includes'
				OclBoolean t172 = (OclBoolean)t173.includes(self);
				t170 = t172;
				//--- Break the loop ---
				if(!StdLibAdapterImpl.INSTANCE.impl(t170).booleanValue()) break;
			}

			//--- Print result ---
			log.reportMessage(": "+t170);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		//--- Print invariant ---
		invariant = "context AS::Association inv one_at_other_of_two_and_vice_versa : associationEnd -> size() = 1 or ( associationEnd -> size() = 2 and associationEnd -> first() . otherEnd = associationEnd -> last() and associationEnd -> last() . otherEnd = associationEnd -> first() )";
		log.printMessage("  "+invariant);

		try {
			OclBoolean t175;
			try {
				// Call property 'associationEnd'
				OclSequence t178 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
				// Call operation 'size'
				OclInteger t177 = (OclInteger)t178.size();
				// Call operation 'equalTo'
				OclBoolean t176 = StdLibAdapterImpl.INSTANCE.Boolean(t177.equals(StdLibAdapterImpl.INSTANCE.Integer(1)));
				t175 = t176;
			} catch (Exception e) {
				t175 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			OclBoolean t179;
			try {
				OclBoolean t181;
				try {
					OclBoolean t183;
					try {
						// Call property 'associationEnd'
						OclSequence t186 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
						// Call operation 'size'
						OclInteger t185 = (OclInteger)t186.size();
						// Call operation 'equalTo'
						OclBoolean t184 = StdLibAdapterImpl.INSTANCE.Boolean(t185.equals(StdLibAdapterImpl.INSTANCE.Integer(2)));
						t183 = t184;
					} catch (Exception e) {
						t183 = StdLibAdapterImpl.INSTANCE.Undefined();
					}
					OclBoolean t187;
					try {
						// Call property 'associationEnd'
						OclSequence t191 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
						// Call operation 'first'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t190 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t191.first();
						// Call property 'otherEnd'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t189 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t190.getOtherEnd();
						// Call property 'associationEnd'
						OclSequence t193 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
						// Call operation 'last'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t192 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t193.last();
						// Call operation 'equalTo'
						OclBoolean t188 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t189, t192));
						t187 = t188;
					} catch (Exception e) {
						t187 = StdLibAdapterImpl.INSTANCE.Undefined();
					}
					// Call operation 'and'
					OclBoolean t182 = t183.and(t187);
					t181 = t182;
				} catch (Exception e) {
					t181 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				OclBoolean t194;
				try {
						// Call property 'associationEnd'
						OclSequence t198 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
						// Call operation 'last'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t197 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t198.last();
						// Call property 'otherEnd'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t196 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t197.getOtherEnd();
						// Call property 'associationEnd'
						OclSequence t200 = StdLibAdapterImpl.INSTANCE.Sequence(self.getAssociationEnd());
						// Call operation 'first'
						uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd t199 = (uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd)t200.first();
						// Call operation 'equalTo'
						OclBoolean t195 = StdLibAdapterImpl.INSTANCE.Boolean(KmfImplementationAdapterImpl.INSTANCE.OclModelElement_equalTo(t196, t199));
					t194 = t195;
				} catch (Exception e) {
					t194 = StdLibAdapterImpl.INSTANCE.Undefined();
				}
				// Call operation 'and'
				OclBoolean t180 = t181.and(t194);
				t179 = t180;
			} catch (Exception e) {
				t179 = StdLibAdapterImpl.INSTANCE.Undefined();
			}
			// Call operation 'or'
			OclBoolean t174 = t175.or(t179);

			//--- Print result ---
			log.reportMessage(": "+t174);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
}
